# The LearningOnline Network
# Communicate
#
# $Id: loncommunicate.pm,v 1.17 2003/10/04 20:49:40 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Internal Server Error Handler
#
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1,11/9 Gerd Kortemeyer)
#
# 3/1/1 Gerd Kortemeyer)
#
# 3/1,2/6,7/27,8/3,8/15,
# 11/5/01 Gerd Kortemeyer
#
package Apache::loncommunicate;

use strict;
use Apache::Constants qw(:common);
use Apache::lonmsg();
use Apache::loncommon;
use Apache::lonlocal;

sub handler {
    my $r = shift;
    &Apache::loncommon::content_type($r,'text/html');
    $r->send_http_header;
    return OK if $r->header_only;
#
# Start document
#
    $r->print(<<END);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
END
   my %lt=&Apache::lonlocal::texthash(
'vam' => 'View All Messages',
'vcm' => 'View Critical Messages',
'smu' => 'Send Message to User(s)',
'bmc' => 'Broadcast Message to Course',
'dmu' => 'Distribute Messages from Uploaded File to Course',
'unr' => 
     'User Notes, Records of Face-to-Face Discussions, and Critical Messages',
'nm' => 'New Messages',
'su' => 'Subject',
'da' => 'Date',
'us' => 'Username',
'op' => 'Open',
'do' => 'Domain'
);

   $r->print(&Apache::loncommon::bodytag("Communication and Messages"));
   $r->print(<<END);
<table cellspacing="10" cellpadding="2">
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email/">$lt{'vam'}</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?critical=display">$lt{'vcm'}</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?compose=individual">$lt{'smu'}</a></b>
</td></tr>
END
    if (($ENV{'request.course.id'}) && 
        (&Apache::lonnet::allowed('srm',$ENV{'request.course.id'}))) {
        $r->print(<<END);
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?compose=group">$lt{'bmc'}</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?compose=upload">$lt{'dmu'}</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?recordftf=query">$lt{'unr'}</a></b>
</td></tr>

END
    }
    $r->print('</table>');
    my @msgids = sort split(/\&/,&Apache::lonnet::reply
                            ('keys:'.$ENV{'user.domain'}.':'.
                             $ENV{'user.name'}.':nohist_email',
                             $ENV{'user.home'}));
    my @newmsgs;
    foreach (@msgids) {
        my ($sendtime,$shortsubj,$fromname,$fromdom,$status)=
	    &Apache::lonmsg::unpackmsgid($_);
       if (defined($sendtime) && $sendtime!~/error/) {
        $sendtime = &Apache::lonlocal::locallocaltime($sendtime);
        if ($status eq 'new') {
            push @newmsgs, { 
                msgid    => $_,
                sendtime => $sendtime,
                shortsub => &Apache::lonnet::unescape($shortsubj),
                from     => $fromname,
                fromdom  => $fromdom 
                }
        }
       }
    }
    if ($#newmsgs >= 0) {
        $r->print(<<TABLEHEAD);
<h3>$lt{'nm'}</h3>
<table border=2><tr><th>&nbsp</th>
<th>$lt{'da'}</th><th>$lt{'us'}</th><th>$lt{'do'}</th><th>$lt{'su'}</th></tr>
TABLEHEAD
        foreach my $msg (@newmsgs) {
            $r->print(<<"ENDLINK");
<tr bgcolor="#FFBB77">
<td><a href="/adm/email?display=$msg->{'msgid'}">$lt{'op'}</a></td>
ENDLINK
            foreach ('sendtime','from','fromdom','shortsub') {
                $r->print("<td>$msg->{$_}</td>");
            }
            $r->print("</td></tr>");
        }
        $r->print('</table></body></html>');
    } else {
        $r->print("<h3>".&mt('You have no unread messages')."</h3>");
    }
    return OK;
}

1;
__END__
